module openmelee.test.wrap;

import blaze.common.bzMath;

private {
	import xf.xpose2.Expose;
	import xf.xpose2.MiniD;
}

char[] mdxpose(char[] name, char[] expStr) {
	return "
	struct MDWrapper__"~name~" {
		mixin(xpose2(`"~name~"`, `"~expStr~"`));
		mixin xposeMiniDNoSubclass!(`"~name~"`);
	}";
}

mixin(mdxpose(`bzVec2`, `
	x|y|
	_ctor overload bzVec2 function(float, float)
`));

void initMD(MDThread* t) {
	pushGlobal(t, "modules");
	field(t, -1, "customLoaders");

	newFunction(t, function uword(MDThread* t, uword numParams)
	{
		xposeMiniD_initAll(t);
		return 0;
	}, "boxen");

	fielda(t, -2, "boxen");
	pop(t, 2);
}
